/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jms;

import beans.GestionnaireDeCompteBancaireLocal;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJB;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import metier.AjoutMontantException;
import metier.RetraitMontantException;

/**
 *
 * @author kaba
 */
@MessageDriven(mappedName = "jms/OrdresTransfertBancaires", activationConfig = {
    @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
    @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
})
public class MBDTransfertBancaire implements MessageListener {

    @EJB
    private GestionnaireDeCompteBancaireLocal gestionnaireDeCompteBancaireBean;

    public MBDTransfertBancaire() {
    }

    public void onMessage(Message message) {
        if (message instanceof ObjectMessage) {
            ObjectMessage om = (ObjectMessage) message;
            try {
                OrdreDeTransfert ordre;
                ordre = (OrdreDeTransfert) om.getObject();

                gestionnaireDeCompteBancaireBean.retirerMontant(ordre.getCompteSource(), ordre.getMontantDeTransfert());
                gestionnaireDeCompteBancaireBean.ajouterMontant(ordre.getCompteDest(), ordre.getMontantDeTransfert());

            } catch (JMSException ex) {
                Logger.getLogger(MBDTransfertBancaire.class.getName()).log(Level.SEVERE, null, ex);
            } catch (RetraitMontantException ex) {
                Logger.getLogger(MBDTransfertBancaire.class.getName()).log(Level.SEVERE, null, ex);
            } catch (AjoutMontantException ex) {
                Logger.getLogger(MBDTransfertBancaire.class.getName()).log(Level.SEVERE, null, ex);
            }


        }
    }
}
