/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package metier;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;

/**
 *
 * @author kaba
 */
@Entity
@NamedQueries({
    @NamedQuery(name = "findAll", query = "SELECT c FROM CompteBancaire c"),
    @NamedQuery(name = "findByName", query = "SELECT c FROM CompteBancaire c WHERE c.nom = :nom"),
    @NamedQuery(name = "findById", query = "SELECT c FROM CompteBancaire c WHERE c.id = :id")
})
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
public class CompteBancaire implements Serializable {

    public enum TypeCompte {COMPTE_COURANT, COMPTE_EPARGNE;

        public static TypeCompte getCOMPTE_COURANT() {
            return COMPTE_COURANT;
        }

        public static TypeCompte getCOMPTE_EPARGNE() {
            return COMPTE_EPARGNE;
        }
    };
    
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
    private String nom;
    
    @ManyToOne
    private Client client;
    private double solde;
    
    @OneToMany(cascade = {CascadeType.ALL}, fetch = FetchType.EAGER, mappedBy = "compteBancaire")
    private Collection<OperationBancaire> operations = new ArrayList<OperationBancaire>();

    public CompteBancaire() {
        client = new Client();
    }
    public CompteBancaire(double solde) {
        client = new Client();
        this.solde = solde;
    }

    public CompteBancaire(String nom, double solde) {
        this.nom = nom;
        this.solde = solde;
    }

    public CompteBancaire(Client client, double solde) {
        this.client = client;
        this.solde = solde;
    }
    

    public Collection<OperationBancaire> getOperations() {
        return operations;
    }

    public void addOperation(OperationBancaire opBancaire){
        if(!operations.contains(opBancaire)){
            operations.add(opBancaire);
        }

    }

    public void setOperations(Collection<OperationBancaire> operations) {
        this.operations = operations;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Client getClient() {
        return client;
    }

    public void setClient(Client client) {
        this.client = client;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public double getSolde() {
        return solde;
    }

    public void setSolde(double solde) {
        this.solde = solde;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CompteBancaire)) {
            return false;
        }
        CompteBancaire other = (CompteBancaire) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return id + " -- " + nom + " Solde: " + solde;
    }

    public void retirer(double aRetirer) {

        solde -= aRetirer;

    }

    public void ajouter(double aAjouter) {

        solde += aAjouter;
    }

    public void consulter() {
        System.out.println("Vous disposez de " + getSolde() + " euros sur votre compte");
    }
}
